program Pro2M;

uses
  Forms,
  SysUtils,
  Controls,
  Windows,
  Dialogs,
  About in 'about.pas' {frAbout},
  Main in 'Main.pas' {frPro2M},
  miReopen in 'miReopen.pas',
  ConfTools in 'ConfTools.pas' {frConfTools};

{$R *.RES}

var hwnd : integer;             //  FindWindow
    wm_need_restore : UINT;     //    Windows

begin
  //     Pro2M
  hwnd := FindWindow ('TfrPro2M', nil);
  if hwnd <> 0 then begin
    if MessageDlg(' Pro2M  ,      ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
      SetForegroundWindow(hwnd);
      wm_need_restore := RegisterWindowMessage(wm_need_restore_string);
      if wm_need_restore <> 0 then PostMessage(hwnd, wm_need_restore, 0, 0);
      exit;
      end;
    end;

  // 
  Application.Initialize;
  Application.CreateForm(TfrPro2M, frPro2M);
  Application.CreateForm(TfrAbout, frAbout);
  Application.CreateForm(TfrConfTools, frConfTools);
  frPro2M.load_ini(ExtractFilePath(ParamStr(0)) + 'Pro2M.ini');
  //     
  if ParamCount > 0 then frPro2M.CreateDefaultPro(ParamStr(1));
  // 
  Application.Run;
end.
