//------------------------------------------------------------------------------
//      miReopen
//    ,      Visible
//  miReopen   >1 -   
//------------------------------------------------------------------------------

unit miReopen;

interface

uses menus;

//  -  miReopen
procedure miReopen_Clear(miReopen : TMenuItem);
//     miReopen    -
procedure miReopen_Del(miReopen : TMenuItem; fName : string);
//     miReopen
procedure miReopen_Add(miReopen : TMenuItem; fName : string);


implementation

//------------------------------------------------------------------------------
//  -  miReopen
procedure miReopen_Clear(miReopen : TMenuItem);
var i : integer;
begin
  //  -
  miReopen.Items[0].Enabled := false;
  miReopen.Items[0].Caption := ' ';
  //  -
  for i := 1 to miReopen.Count - 1 do miReopen.Items[i].Visible := false;
end;//miReopen_Clear


//------------------------------------------------------------------------------
//     miReopen    -
procedure miReopen_Del(miReopen : TMenuItem; fName : string);
var i : integer;
begin
  //   ""
  i := 0;
  while i < miReopen.Count do begin
    //   -
    if not miReopen.Items[i].Visible then exit;
    //     -
    if miReopen.Items[i].Caption = fName then begin
      //    -
      while (i + 1) < miReopen.Count do
        if miReopen.Items[i + 1].Visible then begin
          // - , =>  
          miReopen.Items[i].Caption := miReopen.Items[i + 1].Caption;
          inc(i);
          end
        else begin
          //    -   
          if i > 0 then miReopen.Items[i].Visible := false;
          break;
          end;//else
      //  -   (   )
      if i = miReopen.Count - 1 then miReopen.Items[i].Visible := false;
      //   
      if i = 0 then begin
        miReopen.Items[i].Caption := ' ';
        miReopen.Items[i].Enabled := false;
        end;//if
      end;//if
    //  . -
    inc(i);
    end;//while
end;//miReopen_Del


//------------------------------------------------------------------------------
//     miReopen
procedure miReopen_Add(miReopen : TMenuItem; fName : string);
var i : integer;
    st : string;    //    -
begin
  //  
  if miReopen.Items[0].Caption = fName then exit;
  //    
  st := miReopen.Items[0].Caption;
  miReopen.Items[0].Caption := fName;
  //   
  if not miReopen.Items[0].Enabled then begin
    miReopen.Items[0].Enabled := true;
    exit;
    end;//if
  //  
  i := 1;
  while i < (miReopen.Count - 1) do begin
    if (not miReopen.Items[i].Visible) or (miReopen.Items[i].Caption = fName) then break;
    inc(i);
    end;//while
  miReopen.Items[i].Visible := true;
  // -
  while i > 1 do begin
    miReopen.Items[i].Caption := miReopen.Items[i - 1].Caption;
    dec(i);
    end;//while
  miReopen.Items[i].Caption := st;
end;//miReopen_Add


end.
